<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "directory_component_section".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DirectoryComponentSection".
 *
 * Columns in table "directory_component_section" available as properties of the model,
 * followed by relations of table "directory_component_section" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $description
 *
 * @property DirectoryComponentTemplate[] $directoryComponentTemplates
 * @property DirectoryPartnerLayout[] $directoryPartnerLayouts
 */
abstract class BaseDirectoryComponentSection extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'directory_component_section';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DirectoryComponentSection|DirectoryComponentSections', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('name, description', 'length', 'max'=>100),
            array('description', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, description', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'directoryComponentTemplates' => array(self::HAS_MANY, 'DirectoryComponentTemplate', 'component_section_id'),
            'directoryPartnerLayouts' => array(self::HAS_MANY, 'DirectoryPartnerLayout', 'component_section_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'description' => Yii::t('app', 'Description'),
            'directoryComponentTemplates' => null,
            'directoryPartnerLayouts' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('description', $this->description, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
